###################################################
### chunk number 1: 
###################################################
#line 58 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
options(width=90)


###################################################
### chunk number 2: 
###################################################
#line 61 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
library(phylosim)


###################################################
### chunk number 3: 
###################################################
#line 66 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
cat("((t1:0.3,t2:0.3):0.2,t3:0.1);",file="3taxa.nwk")
cat("((t1:0.3,t2:0.3):0.2,(t3:0.1,t4:0.1):0.4);",file="4taxa.nwk")


###################################################
### chunk number 4: 
###################################################
#line 79 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
Simulate(PhyloSim(
	root.seq=sampleStates( NucleotideSequence(len=50,proc=list(list(JC69())) )),
	phylo=read.tree("3taxa.nwk")
))$alignment


###################################################
### chunk number 5: 
###################################################
#line 89 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
root.seq<-NucleotideSequence(length=50)


###################################################
### chunk number 6: 
###################################################
#line 94 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
print(root.seq)


###################################################
### chunk number 7: 
###################################################
#line 100 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
p<-JC69()


###################################################
### chunk number 8: 
###################################################
#line 105 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
attachProcess(root.seq,p)


###################################################
### chunk number 9: 
###################################################
#line 111 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
sampleStates(root.seq)


###################################################
### chunk number 10: 
###################################################
#line 116 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
print(root.seq)


###################################################
### chunk number 11: 
###################################################
#line 121 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
tree<-read.tree("3taxa.nwk")


###################################################
### chunk number 12: 
###################################################
#line 127 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plot(tree)


###################################################
### chunk number 13: 
###################################################
#line 132 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
sim<-PhyloSim()


###################################################
### chunk number 14: 
###################################################
#line 137 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
sim$phylo<-tree


###################################################
### chunk number 15: 
###################################################
#line 142 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
sim$rootSeq<-root.seq


###################################################
### chunk number 16: 
###################################################
#line 147 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
Simulate(sim)


###################################################
### chunk number 17: 
###################################################
#line 152 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
sim$alignment


###################################################
### chunk number 18: 
###################################################
#line 159 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
p<-HKY(rate.params=list( "Alpha"=10,"Beta"=2),
                     base.freqs=c(4,3,2,1)/10
   )


###################################################
### chunk number 19: 
###################################################
#line 166 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plot(p,scale=0.5)


###################################################
### chunk number 20: 
###################################################
#line 172 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
root.len50.seq<-NucleotideSequence(length=50,processes=list(list(p)))
sampleStates(root.len50.seq)


###################################################
### chunk number 21: 
###################################################
#line 178 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
print(root.len50.seq)


###################################################
### chunk number 22: 
###################################################
#line 183 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
sim<-PhyloSim(
	root.seq=root.len50.seq,
	phylo=read.tree("3taxa.nwk")
);


###################################################
### chunk number 23: 
###################################################
#line 191 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
Simulate(sim)


###################################################
### chunk number 24: 
###################################################
#line 196 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
saveAlignment(sim,file="HKY_sim.fas")


###################################################
### chunk number 25: 
###################################################
#line 199 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
unlink("HKY_sim.fas")


###################################################
### chunk number 26: 
###################################################
#line 204 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plot(sim,num.pages=1)


###################################################
### chunk number 27: 
###################################################
#line 214 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
         p<-GTR(
                     rate.params=list(
                             "a"=1, "b"=2, "c"=3,
                             "d"=1, "e"=2, "f"=3
                     ),
                     base.freqs=c(2,2,1,1)/6
             )


###################################################
### chunk number 28: 
###################################################
#line 225 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
summary(p)


###################################################
### chunk number 29: 
###################################################
#line 231 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
root.seq<-NucleotideSequence(length=50,processes=list( list(p) ))


###################################################
### chunk number 30: 
###################################################
#line 238 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plusGamma(root.seq,p,0.5)


###################################################
### chunk number 31: 
###################################################
#line 243 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
getRateMultipliers(root.seq,p);


###################################################
### chunk number 32: 
###################################################
#line 248 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
sim<-PhyloSim(
	root.seq=sampleStates(root.seq),
	phylo=read.tree("3taxa.nwk")
)


###################################################
### chunk number 33: 
###################################################
#line 256 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
Simulate(sim)


###################################################
### chunk number 34: 
###################################################
#line 261 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plot(sim,num.pages=1,plot.ancestors=FALSE)


###################################################
### chunk number 35: 
###################################################
#line 266 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
saveAlignment(sim,file="Gamma_sim.fas",skip.internal=TRUE)


###################################################
### chunk number 36: 
###################################################
#line 269 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
file.remove("Gamma_sim.fas")


###################################################
### chunk number 37: 
###################################################
#line 279 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
clearStates(root.seq)
sampleStates(root.seq)


###################################################
### chunk number 38: 
###################################################
#line 285 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plusInvGamma(root.seq,p,pinv=0.8,shape=0.5)


###################################################
### chunk number 39: 
###################################################
#line 290 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
sim<-Simulate(
	PhyloSim(
		root.seq=root.seq,
		phylo=rcoal(3)
	)
)
plot(sim,num.pages=1,plot.ancestors=FALSE)


###################################################
### chunk number 40: 
###################################################
#line 301 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
saveAlignment(sim,file="InvGamma_sim.fas",skip.internal=TRUE)


###################################################
### chunk number 41: 
###################################################
#line 304 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
file.remove("InvGamma_sim.fas")


###################################################
### chunk number 42: 
###################################################
#line 313 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
p<-JC69()
root.seq<-NucleotideSequence(len=50,processes=list(list(p)))
sampleStates(root.seq)


###################################################
### chunk number 43: 
###################################################
#line 321 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
 d<-DiscreteDeletor(
                     rate=0.25,
                     sizes=c(1,2),
                     probs=c(1/2,1/2)
   )


###################################################
### chunk number 44: 
###################################################
#line 331 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
 i<-DiscreteInsertor(
                     rate=0.25,
                     sizes=c(1,2),
                     probs=c(1/2,1/2)
   )


###################################################
### chunk number 45: 
###################################################
#line 340 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
i$templateSeq<-NucleotideSequence(length=2,processes=list( list(p) ))


###################################################
### chunk number 46: 
###################################################
#line 349 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
attachProcess(root.seq,d)
attachProcess(root.seq,i)


###################################################
### chunk number 47: 
###################################################
#line 355 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
sim<-Simulate(PhyloSim(
	root.seq=root.seq,
	phylo=rcoal(3)
))


###################################################
### chunk number 48: 
###################################################
#line 363 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plot(sim,num.pages=1,plot.ancestors=FALSE)


###################################################
### chunk number 49: 
###################################################
#line 368 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
saveAlignment(sim,file="indel1_sim.fas",skip.internal=TRUE)


###################################################
### chunk number 50: 
###################################################
#line 371 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
file.remove("indel1_sim.fas")


###################################################
### chunk number 51: 
###################################################
#line 382 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
 i2<-DiscreteInsertor(
                     rate=0.25,
                     sizes=c(1,2,3,4),
                     probs=c(1,2,3,4)/10,
		     template.seq=NucleotideSequence(string="C")	
   )


###################################################
### chunk number 52: 
###################################################
#line 392 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
clearStates(root.seq)


###################################################
### chunk number 53: 
###################################################
#line 398 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
root.seq$processes<-list(list(i2, d, p))


###################################################
### chunk number 54: 
###################################################
#line 403 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
sim<-Simulate(PhyloSim(
	root.seq=sampleStates(root.seq),
	phylo=read.tree("3taxa.nwk")
))


###################################################
### chunk number 55: 
###################################################
#line 411 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plot(sim,num.pages=1,plot.ancestors=FALSE)


###################################################
### chunk number 56: 
###################################################
#line 416 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
saveAlignment(sim,file="indel2_sim.fas",skip.internal=TRUE)


###################################################
### chunk number 57: 
###################################################
#line 419 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
file.remove("indel2_sim.fas")


###################################################
### chunk number 58: 
###################################################
#line 426 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
p<-JC69()
root.seq<-NucleotideSequence(len=100,processes=list(list(p)))
sampleStates(root.seq)


###################################################
### chunk number 59: 
###################################################
#line 434 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
d<-DiscreteDeletor(
                     rate=1,
                     sizes=c(1,2,3),
                     probs=c(3/6,2/6,1/6)
)


###################################################
### chunk number 60: 
###################################################
#line 444 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
i<-DiscreteInsertor(
                     rate=1,
                     sizes=c(1,2,3),
                     probs=c(3/6,2/6,1/6)
)


###################################################
### chunk number 61: 
###################################################
#line 453 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
i$templateSeq<-NucleotideSequence(length=2,processes=list( list(p) ))


###################################################
### chunk number 62: 
###################################################
#line 458 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
attachProcess(root.seq,d)
attachProcess(root.seq,i)


###################################################
### chunk number 63: 
###################################################
#line 464 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
setDeletionTolerance(root.seq,d,0.08 + c(1/2:51,1/51:2))


###################################################
### chunk number 64: 
###################################################
#line 469 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plotParametersAtSites(root.seq,d,"deletion.tolerance")


###################################################
### chunk number 65: 
###################################################
#line 474 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
setInsertionTolerance(root.seq,i,0.08 + c(1/2:51,1/51:2))


###################################################
### chunk number 66: 
###################################################
#line 479 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
sim<-Simulate(PhyloSim(
        root.seq=root.seq,
        phylo=read.tree("4taxa.nwk")
))


###################################################
### chunk number 67: 
###################################################
#line 487 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plot(sim,plot.ancestors=FALSE)


###################################################
### chunk number 68: 
###################################################
#line 492 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
saveAlignment(sim,file="indel3_sim.fas",skip.internal=TRUE)


###################################################
### chunk number 69: 
###################################################
#line 495 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
file.remove("indel3_sim.fas")


###################################################
### chunk number 70: 
###################################################
#line 516 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
jc69<-JC69()
hky<-HKY(rate.params=list( "Alpha"=5,"Beta"=2),
                     base.freqs=c(4,3,2,1)/10
      )


###################################################
### chunk number 71: 
###################################################
#line 524 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
root.seq<-NucleotideSequence(length=100)


###################################################
### chunk number 72: 
###################################################
#line 529 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
attachProcess(root.seq,jc69,1:50)


###################################################
### chunk number 73: 
###################################################
#line 534 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
attachProcess(root.seq,hky,51:100)


###################################################
### chunk number 74: 
###################################################
#line 539 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plusGamma(root.seq,jc69,1,1:25)
plusGamma(root.seq,jc69,0.5,26:50)

plusGamma(root.seq,hky,1,51:75)
plusGamma(root.seq,hky,0.5,76:100)


###################################################
### chunk number 75: 
###################################################
#line 548 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
sim<-Simulate(PhyloSim(
	root.seq=sampleStates(root.seq),
	phylo=rcoal(3)
))


###################################################
### chunk number 76: 
###################################################
#line 556 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plot(sim,num.pages=1,plot.ancestors=FALSE)


###################################################
### chunk number 77: 
###################################################
#line 563 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
p<-F84(base.freqs=c(1,2,3,4));
p$kappa<-1;


###################################################
### chunk number 78: 
###################################################
#line 569 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
root.seq<-NucleotideSequence(length=50,processes=list(list(p)));


###################################################
### chunk number 79: 
###################################################
#line 574 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plusGamma(root.seq,p,1)


###################################################
### chunk number 80: 
###################################################
#line 579 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
tree<-read.tree("4taxa.nwk")


###################################################
### chunk number 81: 
###################################################
#line 585 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
sim<-PhyloSim(
	root.seq=sampleStates(root.seq),
	phylo=tree
)


###################################################
### chunk number 82: 
###################################################
#line 600 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
node.hook <- function(seq) {

	if(!isAttached(seq$sites[[1]],p)){
		return(seq);
	}

	cat("Resampling rate multipliers!\n");
	plusGamma(seq,p,1)
	return(seq)
}


###################################################
### chunk number 83: 
###################################################
#line 614 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plot(sim)


###################################################
### chunk number 84: 
###################################################
#line 621 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
attachHookToNode(sim, node = 6, fun = node.hook)


###################################################
### chunk number 85: 
###################################################
#line 626 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
Simulate(sim)


###################################################
### chunk number 86: 
###################################################
#line 631 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plot(sim,num.pages=1,plot.ancestors=FALSE)


###################################################
### chunk number 87: 
###################################################
#line 644 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
p<-JC69();
root.seq<-NucleotideSequence(length=10)
attachProcess(root.seq,p)


###################################################
### chunk number 88: 
###################################################
#line 651 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
tree<-read.tree("3taxa.nwk");


###################################################
### chunk number 89: 
###################################################
#line 656 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
for(i in 1:3){
	cat(paste("\n\nSimulating replication ",i,"\n\n",sep=""))	

	clearStates(root.seq)
	plusGamma(root.seq,p,0.25)
	sampleStates(root.seq)

	sim<-Simulate(PhyloSim(
		root.seq=root.seq,
		phylo=tree	
	))	
	
	saveAlignment(sim,file=paste("aln_",i,".fas",sep=""))
}


###################################################
### chunk number 90: 
###################################################
#line 673 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
unlink("aln_1.fas");
unlink("aln_2.fas");
unlink("aln_3.fas");


###################################################
### chunk number 91: 
###################################################
#line 691 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
p<-JC69();
root.seq<-NucleotideSequence(length=50)
attachProcess(root.seq,p)


###################################################
### chunk number 92: 
###################################################
#line 698 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
tree<-read.tree("3taxa.nwk");


###################################################
### chunk number 93: 
###################################################
#line 703 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
sim.replicate<-function(i){
        name<-paste("replication_",i,sep="")
        clearStates(root.seq)
        plusGamma(root.seq,p,0.25)
        sampleStates(root.seq)

        sim<-Simulate(PhyloSim(
                name=name,
                root.seq=root.seq,
                phylo=tree,
        ),
            quiet=TRUE
        )

        saveAlignment(sim,file=paste("aln_",i,".fas",sep=""))
        return(sim)
        # return(TRUE)
}


###################################################
### chunk number 94: 
###################################################
#line 732 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
have.mcore <-  is.element("multicore", installed.packages()[,1])

if(have.mcore){
    library(multicore)
}


###################################################
### chunk number 95: 
###################################################
#line 741 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
if(have.mcore){
    nr.replicates<-3
    res.objects<-mclapply(1:nr.replicates, sim.replicate)
    print(res.objects)
}


###################################################
### chunk number 96: 
###################################################
#line 750 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
if(have.mcore){
    plot(res.objects[[1]])
}


###################################################
### chunk number 97: 
###################################################
#line 756 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
unlink("aln_1.fas");
unlink("aln_2.fas");
unlink("aln_3.fas");

unlink("3taxa.nwk");
unlink("4taxa.nwk");


###################################################
### chunk number 98: 
###################################################
#line 768 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
cat("(((t2:0.1231,t4:0.1231):0.2131,(t3:0.0284,t5:0.0284):0.3078):0.1698,t1:0.5060);",file="smalldemotree.nwk")


###################################################
### chunk number 99: 
###################################################
#line 777 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
ll(Site())


###################################################
### chunk number 100: 
###################################################
#line 782 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
PSIM_FAST <- TRUE


###################################################
### chunk number 101: 
###################################################
#line 786 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
wag <- WAG()
jtt <- JTT()
lg <- LG()
pam <- PAM()


###################################################
### chunk number 102: 
###################################################
#line 793 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
summary(wag)


###################################################
### chunk number 103: 
###################################################
#line 797 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plot(wag, scale = 0.8)


###################################################
### chunk number 104: 
###################################################
#line 802 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
cont.del <- ContinuousDeletor(rate = 0.6, max.length = 10, 
    dist = expression(rnorm(1, mean = 5, sd = 3)))


###################################################
### chunk number 105: 
###################################################
#line 807 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
templ.seq.wag <- AminoAcidSequence(length = 10)


###################################################
### chunk number 106: 
###################################################
#line 812 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
templ.seq.lg <- clone(templ.seq.wag)


###################################################
### chunk number 107: 
###################################################
#line 817 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
cont.ins.wag <- ContinuousInsertor(rate = 0.6, max.length = 10, 
    dist = expression(rnorm(1, mean = 5, sd = 3)))


###################################################
### chunk number 108: 
###################################################
#line 823 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
cont.ins.lg <- ContinuousInsertor(rate = 0.6, max.length = 10, 
    dist = expression(rnorm(1, mean = 5, sd = 3)))


###################################################
### chunk number 109: 
###################################################
#line 829 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
processes.site.wag<-list(wag, cont.ins.wag, cont.del)
processes.site.lg<-list(lg, cont.ins.lg, cont.del)

templ.seq.wag$processes <- list(processes.site.wag)
templ.seq.lg$processes <- list(processes.site.lg)


###################################################
### chunk number 110: 
###################################################
#line 840 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
cont.ins.wag$writeProtected <- FALSE
cont.ins.lg$writeProtected <- FALSE


###################################################
### chunk number 111: 
###################################################
#line 846 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
cont.ins.wag$templateSeq <- templ.seq.wag
cont.ins.lg$templateSeq <- templ.seq.lg


###################################################
### chunk number 112: 
###################################################
#line 858 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
cont.ins.wag$insertHook <- function(seq, target.seq, event.pos, 
    insert.pos) {
    plusInvGamma(seq, process = wag, pinv = 0.1, shape = 1)
    return(seq)
}
cont.ins.lg$insertHook <- function(seq, target.seq, event.pos, 
    insert.pos) {
    plusInvGamma(seq, process = lg, pinv = 0.1, shape = 1)
    return(seq)
}


###################################################
### chunk number 113: 
###################################################
#line 873 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
aa.seq <- AminoAcidSequence(length = 60)


###################################################
### chunk number 114: 
###################################################
#line 881 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
process.pattern <- c(rep(list(list(wag, cont.del, cont.ins.wag)), 
    times = 20), rep(list(list(jtt)), times = 20), rep(list(list(lg, 
    cont.del, cont.ins.lg)), times = 20))


###################################################
### chunk number 115: 
###################################################
#line 888 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
aa.seq$processes <- process.pattern


###################################################
### chunk number 116: 
###################################################
#line 894 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
for (i in 1:aa.seq$length) {
    if (isAttached(aa.seq$sites[[i]], jtt)) {
        setRateMultipliers(aa.seq, jtt, qnorm(runif(1,min=0.5,max=1),mean=0.001,sd=0.01), index = i)
    }
    else if (isAttached(aa.seq$sites[[i]], wag)) {
        plusInvGamma(aa.seq, process = wag, pinv = 0.1, shape = 1, 
            index = i)
    }
    else if (isAttached(aa.seq$sites[[i]], lg)) {
        plusInvGamma(aa.seq, process = lg, pinv = 0.1, shape = 1, 
            index = i)
    }
}


###################################################
### chunk number 117: 
###################################################
#line 911 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
sampleStates(aa.seq)
print(aa.seq)


###################################################
### chunk number 118: 
###################################################
#line 917 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plot(aa.seq)


###################################################
### chunk number 119: 
###################################################
#line 922 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
tree <- read.tree(file = "smalldemotree.nwk")


###################################################
### chunk number 120: 
###################################################
#line 927 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
sim <- PhyloSim(phylo = tree, root.seq = aa.seq)
summary(sim)


###################################################
### chunk number 121: 
###################################################
#line 933 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plot(sim)


###################################################
### chunk number 122: 
###################################################
#line 944 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
node.hook <- function(seq) {
    for (site in seq$sites) {
        if (isAttached(site, jtt)) {
            attachProcess(site, pam)
        }
    }
    return(seq)
}


###################################################
### chunk number 123: 
###################################################
#line 956 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
attachHookToNode(sim, node = 8, fun = node.hook)


###################################################
### chunk number 124: 
###################################################
#line 965 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
Simulate(sim)


###################################################
### chunk number 125: 
###################################################
#line 970 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
saveAlignment(sim, file = "example_V3.1_aln.fas", skip.internal = TRUE)


###################################################
### chunk number 126: 
###################################################
#line 974 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plot(sim,num.pages=1)


###################################################
### chunk number 127: 
###################################################
#line 977 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
file.remove("example_V3.1_aln.fas")


###################################################
### chunk number 128: 
###################################################
#line 982 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
rm(PSIM_FAST)


###################################################
### chunk number 129: 
###################################################
#line 989 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
PSIM_FAST <- TRUE


###################################################
### chunk number 130: 
###################################################
#line 993 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
p <- GY94()


###################################################
### chunk number 131: 
###################################################
#line 997 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
p$kappa = 2


###################################################
### chunk number 132: 
###################################################
#line 1001 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
codon.freqs <- abs(rnorm(61, mean = 10, sd = 3))
codon.freqs <- codon.freqs/sum(codon.freqs)
p$equDist <- codon.freqs


###################################################
### chunk number 133: 
###################################################
#line 1007 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
summary(p)


###################################################
### chunk number 134: 
###################################################
#line 1012 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plot(p,scale=0.5)


###################################################
### chunk number 135: 
###################################################
#line 1017 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
d<-DiscreteDeletor(
        rate=1,
        sizes=1:4,
        probs=c(4,3,2,1)/10
);


###################################################
### chunk number 136: 
###################################################
#line 1026 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
i<-DiscreteInsertor(
        rate=1.5,
        sizes=1:4,
        probs=c(4,3,2,1)/10,
        template.seq=CodonSequence(length=4,processes=list(list(p)))
);


###################################################
### chunk number 137: 
###################################################
#line 1036 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
s<-CodonSequence(length=30,processes=list(list(p)))


###################################################
### chunk number 138: 
###################################################
#line 1041 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
omegaVarM3(s,p,omegas=c(0,0.5,1),probs=c(2/4,1/4,1/4))


###################################################
### chunk number 139: 
###################################################
#line 1046 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plotParametersAtSites(s,p,"omega");


###################################################
### chunk number 140: 
###################################################
#line 1051 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
sampleStates(s)


###################################################
### chunk number 141: 
###################################################
#line 1055 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
sim <- PhyloSim(root.seq = s, phylo = read.tree("smalldemotree.nwk"))


###################################################
### chunk number 142: 
###################################################
#line 1060 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
node.hook <- function(seq) {
	setOmegas(seq, p, 1)
	attachProcess(seq, d)
	attachProcess(seq, i)
	return(seq)
}
attachHookToNode(sim, node = 8, fun = node.hook)


###################################################
### chunk number 143: 
###################################################
#line 1074 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
rm(PSIM_FAST)


###################################################
### chunk number 144: 
###################################################
#line 1079 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
Simulate(sim)


###################################################
### chunk number 145: 
###################################################
#line 1084 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plot(sim,num.pages=1)


###################################################
### chunk number 146: 
###################################################
#line 1089 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
nsyn.subst<-exportStatTree(sim,"nr.nsyn.subst")


###################################################
### chunk number 147: 
###################################################
#line 1094 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plot(nsyn.subst)
nodelabels()


###################################################
### chunk number 148: 
###################################################
#line 1100 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
saveAlignment(sim, file = "example_V3.2_aln.fas", )


###################################################
### chunk number 149: 
###################################################
#line 1103 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
file.remove("example_V3.2_aln.fas")


###################################################
### chunk number 150: 
###################################################
#line 1114 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
PSIM_FAST<-TRUE;


###################################################
### chunk number 151: 
###################################################
#line 1119 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
ivd<-DiscreteInsertor(rate=0.06,sizes=c(4,6),probs=c(2/3,1/3));


###################################################
### chunk number 152: 
###################################################
#line 1124 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
ivd$templateSeq<-NucleotideSequence(length=1);


###################################################
### chunk number 153: 
###################################################
#line 1131 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
ivd$generateBy<-function(process=NA,length=NA,target.seq=NA,event.pos=NA,insert.pos=NA){
	# get the target sequence length
	target.length<-target.seq$length;
	# construct a vector with the positions to copy:
	positions<-(insert.pos+1):(insert.pos + length)
	# discard illegal positions:
	positions<-positions[ positions > 0 & positions <= target.length];
	# copy subsequence
	insert<-copySubSequence(target.seq,positions,process);
	# reverse complement sequence,
	# take care, the class of this objects is "Sequence":
	revComp.NucleotideSequence(insert);
	# do not allow nested insertions:
	setRateMultipliers(insert,ivd,0);
	# return insert	
	return(insert);
}


###################################################
### chunk number 154: 
###################################################
#line 1153 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
p<-JC69();


###################################################
### chunk number 155: 
###################################################
#line 1158 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
s<-NucleotideSequence(length=50)


###################################################
### chunk number 156: 
###################################################
#line 1162 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
s$processes<-list(list(p,ivd))


###################################################
### chunk number 157: 
###################################################
#line 1168 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
sampleStates(s)


###################################################
### chunk number 158: 
###################################################
#line 1172 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
detachProcess(s,p)


###################################################
### chunk number 159: 
###################################################
#line 1177 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plusInvGamma(s,ivd,pinv=0.7,shape=0.5)


###################################################
### chunk number 160: 
###################################################
#line 1181 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
sim<-PhyloSim(root.seq=s, phylo=read.tree("smalldemotree.nwk"));


###################################################
### chunk number 161: 
###################################################
#line 1184 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
file.remove("smalldemotree.nwk");


###################################################
### chunk number 162: 
###################################################
#line 1188 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
Simulate(sim)


###################################################
### chunk number 163: 
###################################################
#line 1192 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plot(sim,num.pages=1)


###################################################
### chunk number 164: 
###################################################
#line 1197 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
saveAlignment(sim,file="example_V3.3.fas");


###################################################
### chunk number 165: 
###################################################
#line 1200 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
file.remove("example_V3.3.fas");


###################################################
### chunk number 166: 
###################################################
#line 1204 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
rm(PSIM_FAST);


###################################################
### chunk number 167: 
###################################################
#line 1239 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
PSIM_FAST<-TRUE;


###################################################
### chunk number 168: 
###################################################
#line 1246 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
part<-list();


###################################################
### chunk number 169: 
###################################################
#line 1251 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
part$nc1<-list(
		"type"="noncoding",
		"len"=1000,
		"subst"=NA,
		"ins"=NA,
		"del"=NA,
		"gamma.shape"=0.5
	);

part$nc1$subst<-GTR(
        rate.params=list(
                "a"=1, "b"=2, "c"=3,
                "d"=1, "e"=2, "f"=3
        ),
        base.freqs=c(1.5,1,1.5,1)/5
)

part$nc1$ins<-DiscreteInsertor(
	rate=0.025,sizes=1:6,
	probs=6:1/21,
	template.seq=NucleotideSequence(string="CCCCCC")
);

part$nc1$del<-DiscreteDeletor(
        rate=0.025,
        sizes=1:6,
        probs=6:1/21
);


###################################################
### chunk number 170: 
###################################################
#line 1284 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
part$e1<-list(
		"type"="first.exon",
		"len"=400,
		"subst"=NA,
		"ins"=NA,
		"del"=NA,
		"omegas"=c(0,1,1.1),
		"omega.probs"=c(4,2,1)/5
	);


###################################################
### chunk number 171: 
###################################################
#line 1297 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
part$e1$subst<-GY94(kappa=2,scale.nuc=TRUE);

part$e1$ins<-DiscreteInsertor(
        rate=0.025,
        sizes=1:2,
        probs=c(2/3,1/3),
        template.seq=CodonSequence(length=2,processes=list(list(part$e1$subst)))
);


part$e1$del<-DiscreteDeletor(
        rate=0.025,
        sizes=1:2,
        probs=c(2/3,1/3)
);


f84<-F84();
f84$kappa<-1.8;

gy94.e2_5<-clone(part$e1$subst);
gy94.e2_5$kappa<-1.5


###################################################
### chunk number 172: 
###################################################
#line 1323 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
del.introns<-DiscreteDeletor(
        rate=0.025,
	sizes=1:8,
        probs=8:1/36
);

ins.introns<-DiscreteInsertor(
        rate=0.025,
        sizes=1:8,
        probs=8:1/36,
        template.seq=NucleotideSequence(length=8,processes=list(list(f84)))
);

for(i in 1:4){
	part[[paste("i",i,sep="")]]<-list(
		"type"="intron",
		"len"=200,
		"subst"=f84,
		"ins"=ins.introns,
		"del"=del.introns,
		"gamma.shape"=abs(rnorm(1,mean=1,sd=0.2))
	)
	part[[paste("e",i+1,sep="")]]<-list(
		"type"="exon",
		"len"=200,
		"subst"=gy94.e2_5,
		"ins"=NA,
		"del"=NA,
		"omegas"=c(0,0.5),
		"omega.probs"=c(3/4,1/4)
	)

}


###################################################
### chunk number 173: 
###################################################
#line 1360 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
part$i5<-list(
		"type"="intron",
                "len"=200,
                "subst"=f84,
                "ins"=ins.introns,
                "del"=del.introns,
                "gamma.shape"=abs(rnorm(1,mean=1,sd=0.1))
)
rm(f84,gy94.e2_5,del.introns,ins.introns);


###################################################
### chunk number 174: 
###################################################
#line 1373 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
part$e6<-list(
		"type"="last.exon",
		"len"=400,
		"subst"=NA,
		"ins"=NA,
		"del"=NA,
		"omegas"=c(0,1,1.1),
		"omega.probs"=c(4,2,1)/5
);

tmp<-clone(part$e1$subst);
tmp$kappa<-0.5;
part$e6$subst<-tmp;

part$e6$del<-DiscreteDeletor(
        rate=0.025,
        sizes=1:4,
        probs=c(4,3,2,1)/10
);

part$e6$ins<-DiscreteInsertor(
        rate=0.025,
        sizes=1:2,
        probs=c(1/3,2/3),
        template.seq=CodonSequence(length=2,processes=list(list(part$e6$subst)))
);


###################################################
### chunk number 175: 
###################################################
#line 1403 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
part$nc2<-list(
		"type"="noncoding",
		"len"=1400,
		"subst"=K80(rate.params=list(Alpha = 2, Beta = 1)),
		"ins"=NA,
		"del"=NA,
		"gamma.shape"=0.5
	);


###################################################
### chunk number 176: 
###################################################
#line 1416 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
s<-Sequence(length=5000);


###################################################
### chunk number 177: 
###################################################
#line 1421 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
nuc<-NucleotideAlphabet();
cod<-CodonAlphabet();


###################################################
### chunk number 178: 
###################################################
#line 1427 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
stop.alphabet<-Alphabet(symbols=c("TAG","TAA","TGA"));


###################################################
### chunk number 179: 
###################################################
#line 1432 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
stop.subst<-GeneralSubstitution(
		alphabet=stop.alphabet,
		rate.list=list(
				"TAG->TAA"=1,
				"TAG->TGA"=2,
				"TAA->TAG"=3,
				"TAA->TGA"=1,
				"TGA->TAG"=2,
				"TGA->TAA"=3
			)
		);


###################################################
### chunk number 180: 
###################################################
#line 1447 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plot(stop.subst,scale=0.5);


###################################################
### chunk number 181: 
###################################################
#line 1454 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
pos<-0;
for(i in part){
	beg<-pos+1;	
	end<-pos+i$len;	
	range<-beg:end;


	if( (i$type=="noncoding") | (i$type=="intron") ){
		setAlphabets(s,list(nuc),range);
	}
	else {
		setAlphabets(s,list(cod),range);
	}
	
	if(!is.na(i$del)){
		attachProcess(s,i$del,range);
	}
	if(!is.na(i$ins)){
		attachProcess(s,i$ins,range);
	}

	if( (i$type=="noncoding") | (i$type=="intron")){
		attachProcess(s,i$subst,range);

		plusInvGamma(this=s,process=i$subst,pinv=0.6,shape=i$gamma.shape,range);
		if(i$type=="intron"){
			# fix splicing sites
			setStates(s,c("G","T","A","G"),c(beg,beg+1,end-1,end));
			setRateMultipliers(s,i$subst,0,c(beg,beg+1,end-1,end));
			setInsertionTolerance(s,i$ins,0,c(beg,beg+1,end-1,end));
			setDeletionTolerance(s,i$del,0,c(beg,beg+1,end-1,end));
		}
	} 
	else if(i$type=="exon"){
		attachProcess(s,i$subst,range);

		omegaVarM3.CodonSequence(s,i$subst,i$omegas,i$omega.probs,range);
	}
	if(i$type=="first.exon"){
		attachProcess(s,i$subst,range);
		# Fix start codon:
		setStates(s,"ATG",beg);
		setRateMultipliers(s,i$subst,0,beg)
		setInsertionTolerance(s,i$ins,0,beg);
		setDeletionTolerance(s,i$del,0,beg);
	}
	if(i$type=="last.exon"){
		attachProcess(s,i$subst,range);
		# Detach GY94 from last site:
		detachProcess(s,i$subst,end);
		# Replace alphabet:
		setAlphabets(s,list(stop.alphabet),end);
		# Attach stop codon process:
		attachProcess(s,stop.subst,end);
		# Sample stop codon:
		sampleStates(s,end);
		# Protect against indels:
		setInsertionTolerance(s,i$ins,0,end);
		setDeletionTolerance(s,i$del,0,end);
	}
	
	pos<-end;
}


###################################################
### chunk number 182: 
###################################################
#line 1522 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
sampleStates(s);


###################################################
### chunk number 183: 
###################################################
#line 1527 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
sim<-PhyloSim(root.seq=s, phylo=rcoal(3));


###################################################
### chunk number 184: 
###################################################
#line 1532 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
scaleTree(sim,0.15/sim$treeLength);


###################################################
### chunk number 185: 
###################################################
#line 1537 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
Simulate(sim)


###################################################
### chunk number 186: 
###################################################
#line 1542 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
plot(sim,num.pages="auto",plot.ancestors=FALSE)


###################################################
### chunk number 187: 
###################################################
#line 1547 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
saveAlignment(sim,file="example_V3.4.fas");


###################################################
### chunk number 188: 
###################################################
#line 1550 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
file.remove("example_V3.4.fas");


###################################################
### chunk number 189: 
###################################################
#line 1555 "d:/Rcompile/CRANpkg/local/2.12/phylosim/inst/doc/PhyloSim.Rnw"
rm(PSIM_FAST)


